import React from 'react';
import { ConnectDropTarget } from 'react-dnd';
import './tree-node.css';
import { TreeItem, TreePath } from '.';
export interface TreeNode {
    node: TreeItem;
}
export interface FlatDataItem extends TreeNode, TreePath {
    lowerSiblingCounts: number[];
    parentNode: TreeItem;
}
export interface TreeRendererProps {
    treeIndex: number;
    treeId: string;
    swapFrom?: number | undefined;
    swapDepth?: number | undefined;
    swapLength?: number | undefined;
    scaffoldBlockPxWidth: number;
    lowerSiblingCounts: number[];
    rowDirection?: 'ltr' | 'rtl' | string | undefined;
    listIndex: number;
    children: JSX.Element[];
    style?: React.CSSProperties | undefined;
    connectDropTarget: ConnectDropTarget;
    isOver: boolean;
    canDrop?: boolean | undefined;
    draggedNode?: TreeItem | undefined;
    getPrevRow: () => FlatDataItem | undefined;
    node: TreeItem;
    path: number[];
}
declare const TreeNode: React.FC<TreeRendererProps>;
export default TreeNode;
